#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "external.h"


double fast_pair_um(int no_res1,int no_res2,double **mat2,double gap_pen,
		    double sqr_cutoff){



register int jj,kk,i,l;
int m,n;
double sigma;
double dum1,dum2,gap0max;
double max_score;
double score;

/* Calculate maximum possible score */

max_score=(MIN(no_res1,no_res2)) * sqr_cutoff;


/* Allocate memory for matrices of lengths of each

	      2 sequences + 1 */

gap2=dmatrix(0,no_res1,0,no_res2);

gap1=dmatrix(0,no_res1,0,no_res2);

gap0=dmatrix(0,no_res1,0,no_res2);


/* Initialise matrices */

for(j=0;j<=no_res1;++j){

   gap2[j][0]=gap1[j][0]=gap0[j][0]=0.0;

}
	for(k=0;k<=no_res2;++k){

	    gap2[0][k]=gap1[0][k]=gap0[0][k]=0.0;

	}

/* Score all possible residue matches */

for(j=1;j<=no_res1;++j){

    jj=j-1;

    for(k=1;k<=no_res2;++k){

	kk=k-1;

	/* j-1,k-1 because mat2 is 0 to len-1 */

	sigma=mat2[j-1][k-1];


        /******** Determine gap0[j][k] ********/


	gap0max=gap0[jj][kk];

	dum1=gap2[jj][kk]-gap_pen;

	dum2=gap1[jj][kk]-gap_pen;

	if(gap0max < dum1){

	  gap0max=dum1;

	}

        if(gap0max < dum2){

	  gap0max=dum2;

	}

	gap0[j][k]=gap0max + sigma;


        /******** Determine gap2[j][k] ********/


	gap2[j][k]=gap2[jj][k];

	if(gap2[jj][k] < gap0[jj][k]){

	   gap2[j][k]=gap0[jj][k];

	}

	/******** Determine gap1[j][k] ********/


	gap1[j][k]=gap1[j][kk];
	

	if(gap1[j][kk] < gap0[j][kk]){

	   gap1[j][k]=gap0[j][kk];

	}
   }

}

/* Locate high edge value */

m=no_res1;

n=no_res2;

score=gap1[m][n];

if(score < gap2[m][n]){

  score=gap2[m][n];

}

  if(score < gap0[m][n]){

    score=gap0[m][n];

  }


free_dmatrix(gap2,0,no_res1,0,no_res2);
free_dmatrix(gap1,0,no_res1,0,no_res2);
free_dmatrix(gap0,0,no_res1,0,no_res2);


/* Successful return value */

/* Normalize score so that the maximum value of function = 1.0 */

return (score/max_score);

}

