#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "external.h"


/* changes : 8.8.96 MSJ removed limit on pdb filename length
                         removed requirement for .pdb as ending of input file
                         removed requirement for ga_fit.inp file: defaults
                         now set internally if no file is found.
*/

int ga_fit(int list1[MAX_SEQ],int nlist1,int list2[MAX_SEQ],
	   int nlist2,double *score_a,int *end_no_bestca,
	   int mat,int pen,int *t_len){



FILE *infp;



int i;
int test;
double cut_off;
double maxdist;
int length;
double fittest;
double score_b;
int exercist;



/* Open ga_fit.inp file */

exercist=0;
if((infp=fopen(INPUT,"r"))==NULL){
  fprintf(stderr,"File %s cannot be opened\n",INPUT);
  fprintf(stderr,"Setting default values ...\n");
  if((initdata1(&test,&cut_off,&maxdist))!=0){
	   fprintf(stderr,"Error in setting defaults\n");
	   exit(1);
  }
  exercist=1;
}

else if((initdata(infp,&test,&cut_off,&maxdist))!=0){
   fprintf(stderr,"Error in reading file %s\n",INPUT);
   exit(1);
}
/* Close ga_fit.inp file */

if(exercist==0)fclose(infp);


length = initialize(maxdist,list1,nlist1,list2,nlist2);

if (length != MAXSTRING){
   fprintf(stderr,"Error in initialization for GA\n");
   exit(1);
}

printf(" \n\n GA Parameters\n");
printf(" -------------\n");
printf(" Total Population size              =   %d\n",popsize);
printf(" Chromosome length                  =   %d\n",length);
printf(" Maximum # of generations           =   %d\n",maxgen);
printf(" Crossover probability              =   %0.1f\n", pcross);
printf(" Mutation  probability              =   %0.3f\n\n", pmutation);
printf(" Testing for termination every %d generations\n",test);
printf(" ---------------------------------------------\n\n");
printf(" Distances in Angstroms\n");
printf(" Rotation angles in Degrees\n\n");
printf(" Cut-off distance for equivalences  =   %0.1f\n",cut_off);
printf(" ---------------------------------\n\n");
printf(" Alignment method : global (Fredman, 1984)\n");
printf(" ----------------------------------------\n");
printf(" Maximum similarity value for match =   %0.1f\n",maxdist);
printf(" Similarity value for mismatch      =   %0.1f\n",MISMATCH);
printf(" Maximum gap penalty (length-independent) = %0.1f\n\n\n",MAXGAP);


    for(gen=1;gen <= maxgen;gen++){

	    if((generation(length,maxdist,list1,nlist1,list2,nlist2))!=0){
	       fprintf(stderr,"Error in generation and evaluation ");
	       fprintf(stderr,"of a new GA population\n");
	       exit(1);
	    }

	    if((statistics(popsize,&max,&avg,&min,&sumfitness,newpop,length))!=0){
	       fprintf(stderr,"Error in calculation of population statistics ");
	       fprintf(stderr,"for generation %d\n",gen);
	       exit(1);
	    }

	    for(i=0;i < popsize;i++)
		oldpop[i] = newpop[i];

	    if(gen==1)
	      fittest = bestfit.fitness;

	    /* Test for termination */

	    else if(gen%test==0){

		   if(bestfit.fitness==fittest)
		      break;

		   else
		      fittest = bestfit.fitness;
	    }
    }

    bestfit.no_bestca = print_objfunc(bestfit.chrom,ca,list1,nlist1,list2,nlist2,
				      maxdist,score_a,&score_b,t_len,end_no_bestca,
				      mat,pen);



return ((int) score_b);
}
