/*

  To define appropriate residue numbering for common equivalence residues

  Alex May 13 October 1994

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "external.h"

extern char seq[MAX_SEQ][MAX_LEN];
extern int len[MAX_SEQ];
extern int ren[MAX_SEQ];

int common_equiv(int no_struc, const int *all_equiv, int **mat){

register int i,j;

register int threshold;
int *no_res;

threshold = (SQR(no_struc) - no_struc)/2.0;

no_res=ivector(0,no_struc-1);

for(i=0;i<no_struc;i++){

   no_res[i]=0;

   for(j=0;j<len[i];j++){

      if(isalpha(seq[i][j+1])){

	no_res[i]++;

	if(no_res[i] > ren[i]){
	  fprintf(stderr,"Error0 in common_equiv()\n");
	  exit(1);
	}

	if(all_equiv[j] == threshold)
	  mat[i][j]=no_res[i]-1;
      }
   }
}

free_ivector(no_res,0,no_struc-1);

return 0;
}
