/* 
	3-operators: Reproduction (select)
		     Crossover (crossover)
		     Mutation (mutation)
*/



#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "external.h"

int select(int popsize,double *sumfitness,struct individual pop[MAXPOP])

/*
	Select a single individual via roulette wheel selection
*/

{
	double randpnt,partsum; /* Random point on wheel, partial sum */
	int j; /* population index */
	partsum=0.0;
	j=0;
   
	randpnt=RANDOM * (*sumfitness);

	
		while((partsum < randpnt)&&(j < popsize)){

			partsum += pop[j].fitness;
			j++;
		}


	return j-1;
}


int mutation(int alleleval,float pmutation,int *nmutation)
{
	int mutate;
	
	mutate=flip(pmutation);
	
	if(mutate)
	  {
	  *nmutation+=1;
	  return(!alleleval);
	  }
	else
	   return alleleval;
} 

int crossover(int *parent1,int *parent2,int *child1,int *child2,
	      int lchrom,int *ncross,int *nmutation,int *jcross,
	      float pcross,float pmutation)
{
	int j;

	if(flip(pcross))
	  {
		*jcross=rnd(0,lchrom-2);
		*ncross+=1;
	  }
	else
		*jcross=lchrom;

	for(j=0;j<=(*jcross);j++)
		{
		 child1[j]=mutation(parent1[j],pmutation,nmutation);
		 child2[j]=mutation(parent2[j],pmutation,nmutation);
		}
		if(*jcross!=lchrom)
		  {
			for(j=(*jcross+1);j<=lchrom;j++)
				{
				 child1[j]=mutation(parent2[j],pmutation,nmutation);
				 child2[j]=mutation(parent1[j],pmutation,nmutation);
				}
		  }
	return 0;
}
