#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "external.h"

#define MAX_NAME 25
#define SUFFIX ".fit"




extern char pdb_filename[MAX_SEQ][MAX_NAME];	/* array of PDB filenames */
extern int ren[MAX_SEQ];
extern struct atom_rec atom;


int write_um (int no_struc){

char line[90];
char string[10];
char *out_filename;

register int i,j;


FILE *fp1, *fp2;




for(i=0; i<no_struc; i++){

   j=0;

   /* Open each PDB file */

   if((fp1=fopen(pdb_filename[i],"r"))==NULL){
      fprintf(stderr,"File %s cannot be opened",pdb_filename[i]);
      perror(pdb_filename[i]);
      exit(1);
   }

   /* Allocate memory for fitted CA file filename */

   if ((out_filename = (char *) malloc(10)) == NULL){
      fprintf(stderr,"Not enough memory to allocate buffer\n");
      exit(1);  /* terminate program if out of memory */
   }


   strncpy(out_filename,pdb_filename[i],4);
   strcpy(out_filename+4,SUFFIX);


   /* Open each fitted CA file */

   if((fp2=fopen(out_filename,"w"))==NULL){
      fprintf(stderr,"File %s cannot be opened",out_filename);
      perror(out_filename);
      exit(1);
   }


   /* Read PDB file and extract CA atoms */

   while (fgets(line,90,fp1)) {

	 if (read_Brookhaven_ATOM_record( line ) != -1) {

	    if (strcmp( atom.atom_name, "CA " ) == 0) {

	       sprintf(string,"%7.3f",start_ca[i][j][0]);
	       strncpy(line+31,string,6);

	       sprintf(string,"%7.3f",start_ca[i][j][1]);
	       strncpy(line+39,string,6);

	       sprintf(string,"%7.3f",start_ca[i][j][2]);
	       strncpy(line+47,string,6);

	       fputs(line,fp2);

	       if (j == ren[i] ) {
		  fprintf( stderr, "Error in producing file %s\n",
								out_filename);
		  break;
	       }

	       j++;

	    }
	 }
   }

   /* Close each PDB file and fitted CA file */

   fclose(fp1);
   fclose(fp2);

   /* Free memory */

   free(out_filename);

}

return 0;
}





